﻿--------------------------------------------------------
--  DDL for Sequence SEQ_CLIENT
--------------------------------------------------------

   CREATE SEQUENCE  "MONITOR"."SEQ_CLIENT"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 4 NOCACHE  ORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Sequence SEQ_CRIDA
--------------------------------------------------------

   CREATE SEQUENCE  "MONITOR"."SEQ_CRIDA"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE  ORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Sequence SEQ_LOG
--------------------------------------------------------

   CREATE SEQUENCE  "MONITOR"."SEQ_LOG"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE  ORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Sequence SEQ_PAS
--------------------------------------------------------

   CREATE SEQUENCE  "MONITOR"."SEQ_PAS"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE  ORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Sequence SEQ_REGISTRE
--------------------------------------------------------

   CREATE SEQUENCE  "MONITOR"."SEQ_REGISTRE"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE  ORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Sequence SEQ_REGLA
--------------------------------------------------------

   CREATE SEQUENCE  "MONITOR"."SEQ_REGLA"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 5 NOCACHE  ORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Table CLIENT
--------------------------------------------------------

  CREATE TABLE "MONITOR"."CLIENT" 
   (	"ID" NUMBER, 
	"NOM" VARCHAR2(50 BYTE), 
	"CIF" VARCHAR2(10 BYTE)
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table ESTADISTIQUES
--------------------------------------------------------

  CREATE TABLE "MONITOR"."ESTADISTIQUES" 
   (	"ANY_EST" NUMBER, 
	"MES_EST" NUMBER, 
	"REGISTRES_DISPONIBLES" NUMBER, 
	"REGISTRES_NO_RESPON" NUMBER, 
	"REGISTRES_NO_RESP_ESP" NUMBER, 
	"SERVEIS_ALTA_DISPO" NUMBER, 
	"SERVEIS_BAIXA_DISPO" NUMBER, 
	"DIA_MENYS_DISPO" NUMBER, 
	"CLIENT_MENYS_DISPO" NUMBER, 
	"REGLA_MES_LENTA" NUMBER
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table LOG
--------------------------------------------------------

  CREATE TABLE "MONITOR"."LOG" 
   (	"ID" NUMBER, 
	"DATA_HORA" DATE DEFAULT SYSDATE, 
	"CRIDA" NUMBER, 
	"PROCEDIMENT" VARCHAR2(100 BYTE), 
	"PARAMETRE" VARCHAR2(50 BYTE), 
	"TIPUS_PARAMETRE" VARCHAR2(1 BYTE), 
	"VALOR_PARAMETRE" VARCHAR2(2000 BYTE)
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table PAS_MONITORITZACIO
--------------------------------------------------------

  CREATE TABLE "MONITOR"."PAS_MONITORITZACIO" 
   (	"ID" NUMBER, 
	"DESCRIPCIO" VARCHAR2(100 BYTE), 
	"ORDRE" NUMBER, 
	"URL" VARCHAR2(500 BYTE), 
	"TIMEOUT" NUMBER, 
	"PETICIO" VARCHAR2(1000 BYTE), 
	"RESPOSTA" VARCHAR2(500 BYTE), 
	"REGLA" NUMBER
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table REGISTRE_MONITORITZACIO
--------------------------------------------------------

  CREATE TABLE "MONITOR"."REGISTRE_MONITORITZACIO" 
   (	"ID" NUMBER, 
	"DATA_HORA" DATE DEFAULT SYSDATE, 
	"SERVEI" VARCHAR2(10 BYTE), 
	"REGLA" NUMBER, 
	"PAS_DARRER" NUMBER, 
	"TEMPS" NUMBER, 
	"DISPONIBILITAT" VARCHAR2(1 BYTE), 
	"ERROR" VARCHAR2(10 BYTE)
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table REGLA_MONITORITZACIO
--------------------------------------------------------

  CREATE TABLE "MONITOR"."REGLA_MONITORITZACIO" 
   (	"ID" NUMBER, 
	"NOM" VARCHAR2(50 BYTE), 
	"PERIODE" NUMBER, 
	"ACTIVA" NVARCHAR2(1), 
	"SERVEI" VARCHAR2(10 BYTE)
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table REGLES_HISTORIQUES
--------------------------------------------------------

  CREATE TABLE "MONITOR"."REGLES_HISTORIQUES" 
   (	"REGLA" NUMBER, 
	"ORDRE" NUMBER, 
	"ACTIVA" VARCHAR2(1 BYTE), 
	"DATAHORA" DATE DEFAULT SYSDATE
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table SERVEI_WEB
--------------------------------------------------------

  CREATE TABLE "MONITOR"."SERVEI_WEB" 
   (	"ID" VARCHAR2(10 BYTE), 
	"DESCRIPCIO" VARCHAR2(100 BYTE), 
	"TIPUS" VARCHAR2(10 BYTE), 
	"URL" VARCHAR2(500 BYTE), 
	"CLIENT" NUMBER, 
	"ACTIU" VARCHAR2(1 BYTE) DEFAULT 'N'
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table TIPUS_ERROR
--------------------------------------------------------

  CREATE TABLE "MONITOR"."TIPUS_ERROR" 
   (	"CODI" VARCHAR2(10 BYTE), 
	"DESCRIPCIO" VARCHAR2(1000 BYTE)
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table TIPUS_SERVEI
--------------------------------------------------------

  CREATE TABLE "MONITOR"."TIPUS_SERVEI" 
   (	"CODI" VARCHAR2(10 BYTE), 
	"DESCRIPCIO" VARCHAR2(100 BYTE)
   ) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
  --------------------------------------------------------
--  DDL for Index SERVEI_WEB_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "MONITOR"."SERVEI_WEB_PK" ON "MONITOR"."SERVEI_WEB" ("ID") 
  PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Index CLIENT_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "MONITOR"."CLIENT_PK" ON "MONITOR"."CLIENT" ("ID") 
  PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Index TIPUS_ERROR_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "MONITOR"."TIPUS_ERROR_PK" ON "MONITOR"."TIPUS_ERROR" ("CODI") 
  PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Index ESTADISTIQUES_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "MONITOR"."ESTADISTIQUES_PK" ON "MONITOR"."ESTADISTIQUES" ("ANY_EST", "MES_EST") 
  PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Index REGLA_MONITORITZACIO_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "MONITOR"."REGLA_MONITORITZACIO_PK" ON "MONITOR"."REGLA_MONITORITZACIO" ("ID") 
  PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Index REGISTRE_MONITORITZACIO_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "MONITOR"."REGISTRE_MONITORITZACIO_PK" ON "MONITOR"."REGISTRE_MONITORITZACIO" ("ID") 
  PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Index LOG_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "MONITOR"."LOG_PK" ON "MONITOR"."LOG" ("ID") 
  PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Index PAS_MONITORITZACIO_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "MONITOR"."PAS_MONITORITZACIO_PK" ON "MONITOR"."PAS_MONITORITZACIO" ("ID") 
  PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Index TIPUS_SERVEI_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "MONITOR"."TIPUS_SERVEI_PK" ON "MONITOR"."TIPUS_SERVEI" ("CODI") 
  PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  Constraints for Table CLIENT
--------------------------------------------------------

  ALTER TABLE "MONITOR"."CLIENT" ADD CONSTRAINT "CLIENT_PK" PRIMARY KEY ("ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "MONITOR"."CLIENT" MODIFY ("CIF" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."CLIENT" MODIFY ("NOM" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."CLIENT" MODIFY ("ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table TIPUS_ERROR
--------------------------------------------------------

  ALTER TABLE "MONITOR"."TIPUS_ERROR" ADD CONSTRAINT "TIPUS_ERROR_PK" PRIMARY KEY ("CODI")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "MONITOR"."TIPUS_ERROR" MODIFY ("CODI" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table PAS_MONITORITZACIO
--------------------------------------------------------

  ALTER TABLE "MONITOR"."PAS_MONITORITZACIO" ADD CONSTRAINT "PAS_MONITORITZACIO_PK" PRIMARY KEY ("ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "MONITOR"."PAS_MONITORITZACIO" MODIFY ("TIMEOUT" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."PAS_MONITORITZACIO" MODIFY ("URL" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."PAS_MONITORITZACIO" MODIFY ("ORDRE" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."PAS_MONITORITZACIO" MODIFY ("ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table REGISTRE_MONITORITZACIO
--------------------------------------------------------

  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" ADD CONSTRAINT "REGISTRE_MONITORITZACIO_PK" PRIMARY KEY ("ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" MODIFY ("DISPONIBILITAT" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" MODIFY ("TEMPS" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" MODIFY ("PAS_DARRER" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" MODIFY ("REGLA" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" MODIFY ("SERVEI" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" MODIFY ("DATA_HORA" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" MODIFY ("ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table REGLA_MONITORITZACIO
--------------------------------------------------------

  ALTER TABLE "MONITOR"."REGLA_MONITORITZACIO" ADD CONSTRAINT "REGLA_MONITORITZACIO_PK" PRIMARY KEY ("ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "MONITOR"."REGLA_MONITORITZACIO" MODIFY ("SERVEI" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGLA_MONITORITZACIO" MODIFY ("ACTIVA" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGLA_MONITORITZACIO" MODIFY ("PERIODE" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGLA_MONITORITZACIO" MODIFY ("NOM" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGLA_MONITORITZACIO" MODIFY ("ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table ESTADISTIQUES
--------------------------------------------------------

  ALTER TABLE "MONITOR"."ESTADISTIQUES" ADD CONSTRAINT "ESTADISTIQUES_PK" PRIMARY KEY ("ANY_EST", "MES_EST")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "MONITOR"."ESTADISTIQUES" MODIFY ("MES_EST" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."ESTADISTIQUES" MODIFY ("ANY_EST" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table SERVEI_WEB
--------------------------------------------------------

  ALTER TABLE "MONITOR"."SERVEI_WEB" ADD CONSTRAINT "SERVEI_WEB_PK" PRIMARY KEY ("ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "MONITOR"."SERVEI_WEB" MODIFY ("ACTIU" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."SERVEI_WEB" MODIFY ("CLIENT" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."SERVEI_WEB" MODIFY ("TIPUS" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."SERVEI_WEB" MODIFY ("ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table TIPUS_SERVEI
--------------------------------------------------------

  ALTER TABLE "MONITOR"."TIPUS_SERVEI" ADD CONSTRAINT "TIPUS_SERVEI_PK" PRIMARY KEY ("CODI")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "MONITOR"."TIPUS_SERVEI" MODIFY ("CODI" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table LOG
--------------------------------------------------------

  ALTER TABLE "MONITOR"."LOG" ADD CONSTRAINT "LOG_PK" PRIMARY KEY ("ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "MONITOR"."LOG" MODIFY ("ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table REGLES_HISTORIQUES
--------------------------------------------------------

  ALTER TABLE "MONITOR"."REGLES_HISTORIQUES" MODIFY ("DATAHORA" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGLES_HISTORIQUES" MODIFY ("ACTIVA" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGLES_HISTORIQUES" MODIFY ("ORDRE" NOT NULL ENABLE);
  ALTER TABLE "MONITOR"."REGLES_HISTORIQUES" MODIFY ("REGLA" NOT NULL ENABLE);
--------------------------------------------------------
--  Ref Constraints for Table ESTADISTIQUES
--------------------------------------------------------

  ALTER TABLE "MONITOR"."ESTADISTIQUES" ADD CONSTRAINT "ESTADISTIQUES_FK1" FOREIGN KEY ("CLIENT_MENYS_DISPO")
	  REFERENCES "MONITOR"."CLIENT" ("ID") ENABLE;
  ALTER TABLE "MONITOR"."ESTADISTIQUES" ADD CONSTRAINT "ESTADISTIQUES_FK2" FOREIGN KEY ("REGLA_MES_LENTA")
	  REFERENCES "MONITOR"."REGLA_MONITORITZACIO" ("ID") ENABLE;
--------------------------------------------------------
--  Ref Constraints for Table PAS_MONITORITZACIO
--------------------------------------------------------

  ALTER TABLE "MONITOR"."PAS_MONITORITZACIO" ADD CONSTRAINT "PAS_MONITORITZACIO_FK1" FOREIGN KEY ("REGLA")
	  REFERENCES "MONITOR"."REGLA_MONITORITZACIO" ("ID") ENABLE;
--------------------------------------------------------
--  Ref Constraints for Table REGISTRE_MONITORITZACIO
--------------------------------------------------------

  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" ADD CONSTRAINT "REGISTRE_MONITORITZACIO_FK1" FOREIGN KEY ("SERVEI")
	  REFERENCES "MONITOR"."SERVEI_WEB" ("ID") ENABLE;
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" ADD CONSTRAINT "REGISTRE_MONITORITZACIO_FK2" FOREIGN KEY ("REGLA")
	  REFERENCES "MONITOR"."REGLA_MONITORITZACIO" ("ID") ENABLE;
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" ADD CONSTRAINT "REGISTRE_MONITORITZACIO_FK3" FOREIGN KEY ("PAS_DARRER")
	  REFERENCES "MONITOR"."PAS_MONITORITZACIO" ("ID") ENABLE;
  ALTER TABLE "MONITOR"."REGISTRE_MONITORITZACIO" ADD CONSTRAINT "REGISTRE_MONITORITZACIO_FK4" FOREIGN KEY ("ERROR")
	  REFERENCES "MONITOR"."TIPUS_ERROR" ("CODI") ENABLE;
--------------------------------------------------------
--  Ref Constraints for Table REGLA_MONITORITZACIO
--------------------------------------------------------

  ALTER TABLE "MONITOR"."REGLA_MONITORITZACIO" ADD CONSTRAINT "REGLA_MONITORITZACIO_FK1" FOREIGN KEY ("SERVEI")
	  REFERENCES "MONITOR"."SERVEI_WEB" ("ID") ENABLE;
--------------------------------------------------------
--  Ref Constraints for Table REGLES_HISTORIQUES
--------------------------------------------------------

  ALTER TABLE "MONITOR"."REGLES_HISTORIQUES" ADD CONSTRAINT "REGLES_HISTORIQUES_FK1" FOREIGN KEY ("REGLA")
	  REFERENCES "MONITOR"."REGLA_MONITORITZACIO" ("ID") ENABLE;
--------------------------------------------------------
--  Ref Constraints for Table SERVEI_WEB
--------------------------------------------------------

  ALTER TABLE "MONITOR"."SERVEI_WEB" ADD CONSTRAINT "SERVEI_WEB_FK1" FOREIGN KEY ("CLIENT")
	  REFERENCES "MONITOR"."CLIENT" ("ID") ENABLE;
  ALTER TABLE "MONITOR"."SERVEI_WEB" ADD CONSTRAINT "SERVEI_WEB_FK2" FOREIGN KEY ("TIPUS")
	  REFERENCES "MONITOR"."TIPUS_SERVEI" ("CODI") ENABLE;
	  
	  
--------------------------------------------------------
--  DDL for Package PK_CONSULTES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE "MONITOR"."PK_CONSULTES" AS 

  /* Paquet que conté els procediments i estructures relacionats amb operacions de consulta dinàmiques */ 
  
  /** Tipus de registre per dades de serveis no disponibles per un mes*/
  TYPE R_No_Dispo_Mes is RECORD (id_servei VARCHAR2(10)
                            , desc_servei VARCHAR2(100)
                            , client VARCHAR2(100)
                            , id_regla NUMBER
                            , desc_regla VARCHAR2(50)
                            , dia DATE
                            , num_registres NUMBER
                            , percent_dispo NUMBER
                            , temps_dispo NUMBER
                            ); 
  
  /** Tipus de registre per dades de regles de monitoritzacio i el servei associat */
  TYPE R_Regles is RECORD ( data DATE
                          , client VARCHAR2(50)
                          , id_regla NUMBER
                          , desc_regla VARCHAR2(50)
                          , periode NUMBER
                          , codi_servei VARCHAR2(10)
                          , desc_servei VARCHAR2(100)
                          ); 
                          
  /** Tipus de registre per dades de serveis no disponibles actualment*/
  TYPE R_No_Dispo_Actual is RECORD ( codi_servei VARCHAR2(10)
                                    , desc_servei VARCHAR2(100)
                                    , id_regla NUMBER
                                    , desc_regla VARCHAR2(50)
                                    , pas NUMBER
                                    , temps NUMBER
                                    ); 
                            
  /** Col·lecció de registres de tipus R_No_Dispo_Mes */ 
  TYPE T_No_Dispo_Mes IS TABLE OF R_No_Dispo_Mes;
  
    /** Col·lecció de registres de tipus R_Regles */ 
  TYPE T_Regles IS TABLE OF R_Regles;

  /** Col·lecció de registres de tipus R_No_Dispo_Actual */ 
  TYPE T_No_Dispo_Actual IS TABLE OF R_No_Dispo_Actual;
  
  /**
  Procediment que retorna una llista de serveis web que han estat no disponibles en algun moment, es a dir, 
  amb registres de monitorització que indiquen que el servei no respon, per a un any i un mes concrets.
  Retorna les dades agrupades per dia de mes, ordenades per el temps estimat de disponibilitat de forma descendent.
    
    Paràmetres d'entrada:
      P_Any:	Number,	Any 
      P_Mes:	Number,	Mes 

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
      p_Llista_serveis: T_No_Dispo_Mes, Estructura amb la informació dels serveis no disponibles
  */
  PROCEDURE P_consultar_no_dispo_mes(rsp OUT VARCHAR2, p_llista_serveis OUT T_No_Dispo_Mes, p_any NUMBER, p_mes NUMBER);
  
  /**
  Procediment que retorna una llista de regles de monitoritzacio que han estat actives en algun moment per a un dia concret .
    
    Paràmetres d'entrada:
      P_dia:	Date,	dia 
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
      p_Llista_regles: T_Llista_Regles, Estructura amb la informació de les regles de monitorització
  */
  PROCEDURE P_consultar_regles_actives_dia(rsp OUT VARCHAR2, p_llista_regles OUT T_Regles, p_data DATE);
  
  /**
  Procediment que retorna una llista de serveis que actualment no tenen disponibilitat. Per cada servei s’indica la regla i el pas on està fallant, i el temps que porta no disponible.  
  
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
      p_Llista_serveis: T_No_Dispo_Actual, Estructura amb la informació dels serveis no disponibles
  */
  PROCEDURE P_consultar_no_dispo_actual(rsp OUT VARCHAR2, p_llista_serveis OUT T_No_Dispo_Actual);

END PK_CONSULTES;

/
--------------------------------------------------------
--  DDL for Package PK_DATA_WAREHOUSE
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE "MONITOR"."PK_DATA_WAREHOUSE" AS 

  /* Paquet que conté els procediments i estructures relacionats amb les operacions de manteniment de la taula de data warehouse.*/ 
  
  /**
  Procediment que suma un al camp REGISTRES_DISPONIBLES de la taula ESTADISTIQUES, que conté el nombre registres de monitorització que han donat com a resultat “disponibilitat del servei”, per al registre associat al mes de la monitoritzacio. 
  Si el valor actual del camp es 0, inicialitza el camp amb valor 1.
    
    Paràmetres d'entrada:
      P_Any_est:	Number,	Any de la monitoritzacio
      P_Mes_est:	Number,	Mes de la monitoritzacio

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_calcular_disponibilitat(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER);
  
  /**
  Procediment que suma un al camp REGISTRES_NO_RESPON de la taula ESTADISTIQUES, que conté el nombre registres de monitorització que han donat com a resultat “el servei no respon”, per al registre associat al mes de la monitoritzacio.
  Si el valor actual del camp es 0, inicialitza el camp amb valor 1.
    
    Paràmetres d'entrada:
      P_Any_est:	Number,	Any de la monitoritzacio
      P_Mes_est:	Number,	Mes de la monitoritzacio

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_calcular_no_disponibilitat(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER);
  
  /**
  Procediment que suma un al camp REGISTRES_RESP_NO_ESP de la taula ESTADISTIQUES, que conté el nombre registres de monitorització que han donat com a resultat “la resposta no conté la cadena esperada”, per al registre associat al mes de la monitoritzacio.
  Si el valor actual del camp es 0, inicialitza el camp amb valor 1.
    
    Paràmetres d'entrada:
      P_Any_est:	Number,	Any de la monitoritzacio
      P_Mes_est:	Number,	Mes de la monitoritzacio

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_calcular_resp_no_esperada(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER);
  
  /**
  Procediment que troba el percentatge de disponibilitat de tots els servei que s’han monitoritzat durant el mes de la monitoritzacio, calcula el nombre de serveis que han tingut disponibilitat del 95% o més per un costat 
  i el que ha tingut menys del 95% per l’altre costat, i amb els valors resultants actualitza els camps SERVEIS_ALTA_DISPO i SERVEIS_BAIXA_DISPO de la taula ESTADISTIQUES corresponent al registre associat al mes de la monitoritzacio.
    
    Paràmetres d'entrada:
      P_Any_est:	Number,	Any de la monitoritzacio
      P_Mes_est:	Number,	Mes de la monitoritzacio

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_calcular_percentatges_dispo(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER);
  
  /**
  Procediment que calcula el percentatge de disponibilitat de tots els dies del mes de la monitoritzacio per trobar el dia on menys disponibilitat hi ha hagut, 
  i actualitza el camp DIA_MENYS_DISPO de la taula ESTADISTIQUES corresponent al registre associat al mes de la monitoritzacio amb aquest valor.
    
    Paràmetres d'entrada:
      P_Any_est:	Number,	Any de la monitoritzacio
      P_Mes_est:	Number,	Mes de la monitoritzacio

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_calcular_dia_menys_dispo(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER);
  
  /**
  Procediment que calcula el percentatge de disponibilitat per client els servei dels quals s’han monitoritzat durant el mes de la monitoritzacio, 
  i guarda el codi del client amb menys disponibilitat al camp CLIENT_MENYS_DISPO corresponent al registre associat al mes de la monitoritzacio de la taula ESTADISTIQUES.
    
    Paràmetres d'entrada:
      P_Any_est:	Number,	Any de la monitoritzacio
      P_Mes_est:	Number,	Mes de la monitoritzacio

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_calcular_client_menys_dispo(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER);
  
  /**
  Procediment que calcula la regla que mes triga de mitjana, fent els càlculs sobre les regles executades durant el mes de la monitoritzacio, 
  i guarda l’identificador de la regla al camp REGLA_MES_LENTA corresponent al registre associat al mes de la monitoritzacio de la taula ESTADISTIQUES.
    
    Paràmetres d'entrada:
      P_Any_est:	Number,	Any de la monitoritzacio
      P_Mes_est:	Number,	Mes de la monitoritzacio

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_calcular_regla_mes_lenta(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER);
  
  /**
  Procediment que calcula la regla que mes triga de mitjana, fent els càlculs sobre les regles executades durant el mes de la monitoritzacio, 
  i guarda l’identificador de la regla al camp REGLA_MES_LENTA corresponent al registre associat al mes de la monitoritzacio de la taula ESTADISTIQUES.
    
    Paràmetres d'entrada:
      P_Any_est:	Number,	Any de l’estadística
      P_Mes_est:	Number,	Mes de l’estadística

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
      P_Registres_disponibles:	Number,		Nombre total de registres de monitorització que han finalitzat amb disponibilitat del servei
      P_Registres_no_respon:	Number,		Nombre total de registres de monitorització que han finalitzat amb error de no resposta del servei web
      P_Registres_no_resp_esp:	Number,		Nombre total de registres de monitorització que han finalitzat amb error de resposta no esperada
      P_Serveis_alta_dispo:	Number,		Nombre de serveis amb disponibilitat igual o per damunt del 95%
      P_Serveis_baixa_dispo:	Number,		Nombre de serveis amb disponibilitat per davall del 95%
      P_Dia_menys_dispo:	Number,		Dia del mes on menys disponibilitat global hi ha hagut
      P_Client_menys_dispo;	Number,		Client amb els serveis eu han tingut menys disponibilitat durant el mes
      P_Regla_mes_lenta:	Number,		Identificador de la regla de monitorització que més triga de mitja en executar-se incloent tots els seus passos
      
  */
  PROCEDURE P_consultar_estadistiques(rsp OUT VARCHAR2, P_Registres_disponibles OUT NUMBER, P_Registres_no_respon OUT NUMBER, P_Registres_no_resp_esp OUT NUMBER,
                                      P_Serveis_alta_dispo OUT NUMBER, P_Serveis_baixa_dispo OUT NUMBER, P_Dia_menys_dispo OUT NUMBER, P_Client_menys_dispo OUT NUMBER, 
                                      P_Regla_mes_lenta OUT NUMBER, p_any_est NUMBER, p_mes_est NUMBER);
  
  

END PK_DATA_WAREHOUSE;

/
--------------------------------------------------------
--  DDL for Package PK_MANTENIMENT_MESTRES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE "MONITOR"."PK_MANTENIMENT_MESTRES" AS 

  /** Paquet que conté els procediments relacionats amb operacions sobre taules mestres.*/
  
  /**
  P_Crear_Client
  Procediment que crea un nou client a la taula CLIENT amb les dades informades a la crida. 
  L’identificador del nou registre es calcula amb una seqüència.
    Paràmetres Entrada:
      p_Nom:	Varchar2,	Nom comercial del client
      p_Cif:	Varchar2,	CIF del client      
    Paràmetres Sortida: 
      p_Id: Number, Codi del client creat
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_Crear_Client(rsp OUT VARCHAR2, p_id OUT VARCHAR2, p_nom VARCHAR2, p_cif VARCHAR2);
  
  
  /**
  P_Modificar_Client
  Procediment que modifica les dades d’un client ja existent a la taula CLIENT associat a l’identificador que es passa, actualitzant els valors que es passen per paràmetre. 
    Paràmetres Entrada:
      p_Id: Number, Codi del client a modificar
      p_Nom:	Varchar2,	Nom comercial del client
      p_Cif:	Varchar2,	CIF del client      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */ 
  PROCEDURE P_Modificar_Client(rsp OUT VARCHAR2, p_id VARCHAR2, p_nom VARCHAR2, p_cif VARCHAR2);
  
  
   /**
  P_Eliminar_Client
  Procediment que esborra un client ja existent a la taula CLIENT associat a l’identificador que es passa.
  No es permès esborrar un client que té serveis webs associats.
    Paràmetres Entrada:
      p_Id: Number, Codi del client a modificar
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */ 
  PROCEDURE P_Eliminar_Client(rsp OUT VARCHAR2, p_id VARCHAR2);
  
  
  /**
  P_Crear_Tipus_Servei
  Procediment que crea un tipus de servei a la taula TIPUS_SERVEI amb les dades informades a la crida. 
 
    Paràmetres Entrada:
      p_Codi: Varchar2, Codi del tipus de servei
      p_Descripcio:	Varchar2,	Descripció del tipus de servei
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_Crear_Tipus_Servei(rsp OUT VARCHAR2, p_codi VARCHAR2, p_descripcio VARCHAR2);
  
  
  /**
  P_Modificar_Tipus_Servei
  Procediment que modifica les dades d’un tipus de servei ja existent a la taula TIPUS_SERVEI associat a l’identificador que es passa, actualitzant els valors que es passen per paràmetre. 
    
    Paràmetres Entrada:
      p_Codi: Varchar2, Codi del tipus de servei
      p_Descripcio:	Varchar2,	Descripció del tipus de servei
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */ 
  PROCEDURE P_Modificar_Tipus_Servei(rsp OUT VARCHAR2, p_codi VARCHAR2, p_descripcio VARCHAR2);
  
  
   /**
  P_Eliminar_Tipus_Servei
  Procediment que esborra un tipus de servei ja existent associat a l’identificador que es passa. 
  No es permès esborrar un tipus de servei que té serveis webs associats.
  
    Paràmetres Entrada:
      p_Codi: Varchar2, Codi del tipus de servei
  
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */ 
  PROCEDURE P_Eliminar_Tipus_Servei(rsp OUT VARCHAR2, p_codi VARCHAR2);
  
  
  /**
  P_Crear_Tipus_Error
  Procediment que crea un tipus de servei a la taula TIPUS_ERROR amb les dades informades a la crida. 
 
    Paràmetres Entrada:
      p_Codi: Varchar2, Codi del tipus d'error
      p_Descripcio:	Varchar2,	Descripció del tipus d'error
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_Crear_Tipus_Error(rsp OUT VARCHAR2, p_codi VARCHAR2, p_descripcio VARCHAR2);
  
  
  /**
  P_Modificar_Tipus_Error
  Procediment que modifica les dades d’un tipus de servei ja existent a la taula TIPUS_ERROR associat a l’identificador que es passa, actualitzant els valors que es passen per paràmetre. 
    
    Paràmetres Entrada:
      p_Codi: Varchar2, Codi del tipus d'error
      p_Descripcio:	Varchar2,	Descripció del tipus d'error
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */ 
  PROCEDURE P_Modificar_Tipus_Error(rsp OUT VARCHAR2, p_codi VARCHAR2, p_descripcio VARCHAR2);
  
  
   /**
  P_Eliminar_Tipus_Error
  Procediment que esborra un tipus d'error ja existent associat a l’identificador que es passa. 
  No es permès esborrar un tipus d’error que té registres de monitorització associats.
  
    Paràmetres Entrada:
      p_Codi: Varchar2, Codi del tipus de servei
  
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */ 
  PROCEDURE P_Eliminar_Tipus_Error(rsp OUT VARCHAR2, p_codi VARCHAR2);

END PK_MANTENIMENT_MESTRES;

/
--------------------------------------------------------
--  DDL for Package PK_MANTENIMENT_REGISTRES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE "MONITOR"."PK_MANTENIMENT_REGISTRES" AS 

  /* Paquet que conté els procediments relacionats amb les operacions de manteniment sobre registres de monitorització. */ 

 /**
  Procediment que crea un nou registre de monitorització a la taula REGISTRE_MONITORITZACIO, guardant les dades de l'execució per una regla de
  monitorització que ha estat processada pel sistema.
  
  El procediment també comprova que el darrer pas executat sigui el darrer de la regla, i si es així guarda el valor ‘S’ al camp DISPONIBILITAT 
  per indicar que el servei estava disponible; en cas contrari, guarda el valor ‘N’.
  
  Per defecte, si no s'indica cap data, guarda la data d'execució como data de creació del registre.
    
    Paràmetres Entrada:
      P_Servei:	Varchar2,	Identificador del servei monitoritzat
      P_Regla:	Number,	Identificador de la regla aplicada
      P_Pas_darrer:	Number,		Identificador del darrer pas executat
      P_Temps:	Number,		Temps que ha trigat els servei web en respondre en milisegons
      P_Error:	Varchar2,		Codi d’error si s’ha produit
      P_DataHora: Date,   Data i hora d'execució de la monitorització
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
      P_Id: Number, Identificador del registre creat
  */
  PROCEDURE P_crear_registre(rsp OUT VARCHAR2, p_id OUT NUMBER, P_Servei VARCHAR2, P_Regla NUMBER, P_Pas_darrer NUMBER,
                                            P_Temps NUMBER, P_Error VARCHAR2, P_DataHora DATE);
  
  
  /**
  Procediment que esborra tots els registres de monitorització fins l’any anterior.
    
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error

  */
  PROCEDURE P_eliminar_registres(rsp OUT VARCHAR2);

END PK_MANTENIMENT_REGISTRES;

/
--------------------------------------------------------
--  DDL for Package PK_MANTENIMENT_REGLES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE "MONITOR"."PK_MANTENIMENT_REGLES" AS 

  /** Paquet que conté els procediments relacionats amb les operacions de manteniment sobre regles de monitorització. */
  

  /**
  Procediment que crea una nova regla de monitorització a la taula REGLA_MONITORITZACIO. 
  Per defecte, la nova regla es crea com activa i, si existeix cap regla anterior activa, la desactiva.
  Guarda a l'históric de la regla el moment de creació com a primera activació.
    
    Paràmetres Entrada:
      p_Nom:	Varchar2,	Nom descriptiu de la regla
      p_Periode:	Number,	Periodicitat d’execució en segons
      P_Servei:	Varchar2,	Identificador del servei web al que s’aplica      
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
      P_Id: Number, Identificador de la regla creada
  */
  PROCEDURE P_crear_regla(rsp OUT VARCHAR2, p_id OUT NUMBER, p_nom VARCHAR2, p_periode NUMBER, p_servei VARCHAR2);
  
  
  /**
  Procediment que desactiva una regla de monitorització, corresponent a l'identificador indicat en la petició.
  Guarda a l'històric de la regla el moment de la desactivació.
  
    Paràmetres Entrada:
      P_id:	Number,	Identificador de la regla     
    
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error

  */
  PROCEDURE P_desactivar_regla(rsp OUT VARCHAR2, p_id VARCHAR2);
  
  /**
  Procediment que torna a activar una regla desactivada anteriorment i guarda a l'històric de la regla el moment de l'activació.
  
    Paràmetres Entrada:
      P_id:	Number,	Identificador de la regla
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_activar_regla(rsp OUT VARCHAR2, p_id NUMBER);
  
  
  /**
  Procediment que modifica un regla ja existent, actualitzant els valors que es passen per paràmetre.
  
    Paràmetres Entrada:
      P_Id: Number, Identificador de la regla creada
      p_Nom:	Varchar2,	Nom descriptiu de la regla
      p_Periode:	Number,	Periodicitat d’execució en segons
      P_Servei:	Varchar2,	Identificador del servei web al que s’aplica
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error      

  */
  PROCEDURE P_modificar_regla(rsp OUT VARCHAR2, p_id NUMBER, p_nom VARCHAR2, p_periode NUMBER, p_servei VARCHAR2);
  
  /**
  Procediment que crea un pas associat a una regla de monitorització ja existent a la taula PAS_MONITORITZACIO. 
    
    Paràmetres Entrada:
      P_Descripcio:	Varchar2,	Entrada	Descripció del pas
      P_Ordre:	Number,	Ordre d’execució
      P_Url:	Varchar2,	Url del servei web sobre el que es realitza la crida
      P_Timeout:	Number,	Temps màxim per esperar una resposta del servei
      P_Peticio:	Varchar2,	Petició que s’enviarà al servei
      P_Resposta:	Varchar2,	Cadena de text esperada en la resposta del servei
      P_Regla:	Number,	Identificador de la regla a la que pertany
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
      P_Id: Number, Identificador del pas creada
  */
  PROCEDURE P_crear_pas(rsp OUT VARCHAR2, p_id OUT NUMBER, p_descripcio VARCHAR2, P_ordre NUMBER, P_url VARCHAR2,
                        p_timeout NUMBER, p_peticio VARCHAR2, p_resposta VARCHAR2, p_regla NUMBER);
  
  /**
  Procediment que elimina un pas de monitorització ja existent. 
  Per tal de no deixar buits en la seqüència d’ordre de la resta de passos, el procediment re calcula el valor de l’ordre dels que tenen un ordre major al que s’ha borrat.
  
    Paràmetres Entrada:
      P_Id: Number, Identificador del pas creada
      
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error            

  */
  PROCEDURE P_eliminar_pas(rsp OUT VARCHAR2, p_id NUMBER);
  
  /**
  Procediment que modifica un pas ja existent, actualitzant els valors que es passen per paràmetre.
  
    Paràmetres Entrada:
      P_Id: Number, Identificador del pas creada
      P_Descripcio:	Varchar2,	Entrada	Descripció del pas
      P_Ordre:	Number,	Ordre d’execució
      P_Url:	Varchar2,	Url del servei web sobre el que es realitza la crida
      P_Timeout:	Number,	Temps màxim per esperar una resposta del servei
      P_Peticio:	Varchar2,	Petició que s’enviarà al servei
      P_Resposta:	Varchar2,	Cadena de text esperada en la resposta del servei
            
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error      

  */
  PROCEDURE P_modificar_pas(rsp OUT VARCHAR2, p_id NUMBER, p_descripcio VARCHAR2, P_ordre NUMBER, P_url VARCHAR2,
                            p_timeout NUMBER, p_peticio VARCHAR2, p_resposta VARCHAR2);
  

END PK_MANTENIMENT_REGLES;

/
--------------------------------------------------------
--  DDL for Package PK_MANTENIMENT_SERVEIS_WEB
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE "MONITOR"."PK_MANTENIMENT_SERVEIS_WEB" AS 

  /* Paquet que conté els procediments i estructures relacionats amb les operacions sobre serveis web. */
  
  /** Col·lecció de registres de la taula SERVEI_WEB */ 
  TYPE T_Servei_Web IS TABLE OF servei_web%rowtype;
  
  /**
  Procediment que crea un nou servei web a la taula SERVEI_WEB. Per defecte, el nou servei es crea com actiu.

    Paràmetres Entrada:
      p_Id:	Varchar2,	Identificador del servei web
      p_Descripcio:	Varchar2,	Descripció del servei
      p_Tipus:	Varchar2,	Tipus del servei
      p_Url:	Varchar2,	URL principal del servei
      p_Client:	Number,	Codi del client propietari del servei

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_crear_servei_web(rsp OUT VARCHAR2, p_id VARCHAR2, p_descripcio VARCHAR2, p_tipus VARCHAR2, p_url VARCHAR2, p_client NUMBER);
  
  
  /**
  Procediment que desactiva el servei web corresponent a l'identificador indicat en la petició.
  
    Paràmetres Entrada:
      P_id:	Varchar2,	Identificador del servei web      
  
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_donar_de_baixa_servei_web(rsp OUT VARCHAR2, p_id VARCHAR2);
  
  /**
  Procediment que modifica un servei web ja existent, actualitzant els valors que es passen per paràmetre.

    Paràmetres Entrada:
      p_Id:	Varchar2,	Identificador del servei web
      p_Descripcio:	Varchar2,	Descripció del servei
      p_Tipus:	Varchar2,	Tipus del servei
      p_Url:	Varchar2,	URL principal del servei
      p_Client:	Number,	Codi del client propietari del servei

    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
  */
  PROCEDURE P_modificar_servei_web(rsp OUT VARCHAR2, p_id VARCHAR2, p_descripcio VARCHAR2, p_tipus VARCHAR2, p_url VARCHAR2, p_client NUMBER);
  
  
  /**
  Procediment que retorna una llista de serveis web que corresponen als criteris de recerca.
  
    Paràmetres Entrada:
      p_Id:	Varchar2,	Identificador del servei web
      p_Tipus:	Varchar2,	Tipus del servei
      p_Client:	Number,	Codi del client propietari del servei
      p_Actiu: Varchar2, indicador actiu
  
    Paràmetres Sortida: 
      Rsp:	Varchar2,	Indica si l’execució ha finalitzat amb èxit o error
      Llista_serveis: T_Servei_Web, Llista amb el serveis i les seves dades
  */
  PROCEDURE P_consultar_servei_web(rsp OUT VARCHAR2, Llista_serveis OUT T_Servei_Web, p_id VARCHAR2, p_tipus VARCHAR2, p_client NUMBER, p_actiu VARCHAR2);
  
  
END PK_MANTENIMENT_SERVEIS_WEB;

/
--------------------------------------------------------
--  DDL for Package Body PK_CONSULTES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "MONITOR"."PK_CONSULTES" AS

  PROCEDURE P_consultar_no_dispo_mes(rsp OUT VARCHAR2, p_llista_serveis OUT T_No_Dispo_Mes, p_any NUMBER, p_mes NUMBER) AS
        
      v_crida_log NUMBER;
      ex_serveis_no_trobats EXCEPTION;
      ex_data_no_valida EXCEPTION;
      v_data DATE;
      v_num_resultats NUMBER;
      t_llista_serveis T_No_Dispo_Mes;
      
  BEGIN
        
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_MES', 'p_any', 'E', p_any);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_MES', 'p_mes', 'E', p_mes);
            
      --valida que la data formada per el mes i any passats per paràmetre sigui vàlida
      BEGIN
        SELECT TO_DATE(p_mes||'/'||p_any, 'MM/RRRR') INTO v_data
        FROM DUAL;        
      EXCEPTION
        WHEN OTHERS THEN
          RAISE ex_data_no_valida;
      END;
      
      --Cerca dels registres de monitorització amb data d’execució dins el mes i any seleccionats
      --amb indicador de no disponibilitat, i per cada un obté les dades del servei web, 
      --client i regla de monitorització corresponents, així com el càlculs del nombre de registres de no
      --disponibilitat per servei/regla i el percentatge de temps de disponibilitat.
      BEGIN
        SELECT codi_servei, desc_servei, client, codi_regla, nom_regla, dia, registres_no_dispo, 
                ROUND((registres_dispo*periode)/(registres_total*periode)*100,2) percentage_dispo, (registres_dispo*periode)/3600 temps_dispo
        BULK COLLECT INTO t_llista_serveis 
        FROM(
          SELECT sw.id codi_servei, sw.descripcio desc_servei, cli.nom client, 
                  regl.id codi_regla, regl.nom nom_regla, regl.periode periode, 
                  trunc(regi.data_hora,'DD') dia, 
                  COUNT(1)registres_no_dispo,          
                  (SELECT COUNT(1)
                    FROM registre_monitoritzacio rm
                    WHERE rm.data_hora >= TRUNC(TO_DATE(p_mes||'/'||p_any, 'MM/RRRR'),'MM')
                      AND rm.data_hora <= LAST_DAY(TO_DATE(p_mes||'/'||p_any, 'MM/RRRR'))
                      AND rm.regla = regl.id
                  ) registres_total,
                  (SELECT count(1)
                    FROM registre_monitoritzacio rm
                    where rm.data_hora >= TRUNC(TO_DATE(p_mes||'/'||p_any, 'MM/RRRR'),'MM')
                      AND rm.data_hora <= LAST_DAY(TO_DATE(p_mes||'/'||p_any, 'MM/RRRR'))
                      AND rm.disponibilitat = 'S'
                      AND rm.regla = regl.id
                  ) registres_dispo            
          FROM registre_monitoritzacio regi, regla_monitoritzacio regl, servei_web sw, client cli
                    WHERE regi.data_hora >= TRUNC(TO_DATE(p_mes||'/'||p_any, 'MM/RRRR'),'MM')
                      AND regi.data_hora <= LAST_DAY(TO_DATE(p_mes||'/'||p_any, 'MM/RRRR'))
                      AND regi.disponibilitat = 'N'
                      AND regi.regla = regl.id  
                      AND sw.id = regi.servei
                      AND cli.id = sw.client
          GROUP BY sw.id, sw.descripcio, cli.nom, regl.id, regl.nom, regl.periode, trunc(regi.data_hora,'DD')
        )
        order by dia, temps_dispo desc, codi_servei, codi_regla;
            
        p_llista_serveis := t_llista_serveis;
        
        v_num_resultats := t_llista_serveis.COUNT;
      
      EXCEPTION
        WHEN OTHERS THEN
          RAISE ex_serveis_no_trobats;
      END;
      
      IF v_num_resultats = 0 THEN
        RAISE ex_serveis_no_trobats;
      END IF;
	  
      RSP := 'OK'; 
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_MES', 'RSP', 'S', RSP);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_MES', 'p_llista_serveis.COUNT', 'S', v_num_resultats); 
      COMMIT;
      
      EXCEPTION
      WHEN ex_serveis_no_trobats THEN
        RSP := 'ERROR-INFO_NO_TROBADA';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_MES', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN ex_data_no_valida THEN
        RSP:= 'ERROR-DATA_NO_VALIDA';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_MES', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_MES', 'RSP', 'S', RSP);
        COMMIT;
        
  END P_consultar_no_dispo_mes;

  PROCEDURE P_consultar_regles_actives_dia(rsp OUT VARCHAR2, p_llista_regles OUT T_Regles, p_data DATE) AS
        
      v_crida_log NUMBER;
      ex_serveis_no_trobats EXCEPTION;
      ex_data_no_valida EXCEPTION;
      v_data DATE;
      v_num_resultats NUMBER;
      t_llista_regles T_Regles;
      
  BEGIN
        
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_REGLES_ACTIVES_DIA', 'p_data', 'E', p_data);
      
      --sistema fa una cerca de regles de monitorització actives en la data passada,que son:
      -- 1.regles activades a la data passada
      -- 2.regles desactivades a la data passada
      -- 3.regles activades previament a la data passada que no hagin estat desactivades entre l'activació i la data passada;
      --i per cada una obté el servei i el client associats, ordenat per client
      BEGIN
        SELECT p_data, cl.nom, rm.id, rm.nom, rm.periode, rm.servei, sw.descripcio  
        BULK COLLECT INTO t_llista_regles 
        FROM regla_monitoritzacio rm, servei_web sw, client cl
        WHERE (EXISTS (SELECT 1 FROM regles_historiques rh WHERE rh.REGLA = rm.ID AND rh.ACTIVA = 'S' AND trunc(rh.DATAHORA) = p_data)
               OR EXISTS (SELECT 1 FROM regles_historiques rh WHERE rh.REGLA = rm.ID AND rh.ACTIVA = 'N' AND trunc(rh.DATAHORA) = p_data)
               OR EXISTS (SELECT 1 FROM regles_historiques rh WHERE rh.REGLA = rm.ID AND rh.ACTIVA = 'S' AND trunc(rh.DATAHORA) < p_data 
                          AND NOT EXISTS (SELECT 1 FROM regles_historiques rh1 WHERE rh.REGLA = rh1.REGLA AND rh1.ACTIVA = 'N' AND trunc(rh1.DATAHORA) < p_data AND rh.ORDRE < rh1.ORDRE) ))
          AND rm.servei = sw.id
          AND sw.client = cl.id
        ORDER BY sw.client;
          
        p_llista_regles := t_llista_regles;
		
        v_num_resultats := t_llista_regles.COUNT;
      
      EXCEPTION
        WHEN OTHERS THEN
          RAISE ex_serveis_no_trobats;
      END;
      
      IF v_num_resultats = 0 THEN
        RAISE ex_serveis_no_trobats;
      END IF;
      
      RSP := 'OK'; 
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_REGLES_ACTIVES_DIA', 'RSP', 'S', RSP);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_REGLES_ACTIVES_DIA', 'p_llista_regles.COUNT', 'S', v_num_resultats); 
      COMMIT;
                 
     
      EXCEPTION
      WHEN ex_serveis_no_trobats THEN
        RSP := 'ERROR-INFO_NO_TROBADA';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_REGLES_ACTIVES_DIA', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_REGLES_ACTIVES_DIA', 'RSP', 'S', RSP);
        COMMIT;
  
  END P_consultar_regles_actives_dia;

  PROCEDURE P_consultar_no_dispo_actual(rsp OUT VARCHAR2, p_llista_serveis OUT T_No_Dispo_Actual) AS
        
      v_crida_log NUMBER;
      ex_serveis_no_trobats EXCEPTION;
      ex_data_no_valida EXCEPTION;
      v_data DATE;
      v_num_resultats NUMBER;
      t_llista_serveis T_No_Dispo_Actual;
      
  BEGIN
      -- sistema fa una cerca dels serveis web els quals tinguin el darrer registre de monitorització
      -- amb resultat de no disponible per una regla activa
      BEGIN
        SELECT sw.id, sw.descripcio, re.id, re.nom, rm.pas_darrer, 0
        BULK COLLECT INTO t_llista_serveis 
        FROM registre_monitoritzacio rm, regla_monitoritzacio re, servei_web sw
        WHERE rm.disponibilitat = 'N'
          AND (SELECT MAX(rm1.id) FROM registre_monitoritzacio rm1 WHERE rm1.regla = rm.regla) = rm.id
          AND rm.regla = re.id
          AND re.activa = 'S'
          AND rm.servei = sw.id;
  
        --per cada servei que te una regla activa no disponible actualment
        --calcula el temps que porta no disponible a partir de les darreres execucions amb resultat de no disponible
        --a partir de la darrera execució amb resultat disponible
        FOR indx IN 1 .. t_llista_serveis.COUNT LOOP
          FOR registres IN (
            SELECT rm.id, rm.disponibilitat, re.periode
            FROM registre_monitoritzacio rm, regla_monitoritzacio re 
            WHERE regla = t_llista_serveis(indx).id_regla
              AND rm.regla = re.id
            ORDER BY rm.id desc
            )
              
          LOOP
              IF registres.disponibilitat = 'N' THEN
                t_llista_serveis(indx).temps := t_llista_serveis(indx).temps + registres.periode;                
              ELSE 
                EXIT;
              END IF;
              
          END LOOP;
          
          --actualitza el temps que porta no disponible en hores
          t_llista_serveis(indx).temps := t_llista_serveis(indx).temps / 3600;
          
        END LOOP;
        
        p_llista_serveis := t_llista_serveis;
        
        v_num_resultats := t_llista_serveis.COUNT;  
      
      EXCEPTION
        WHEN OTHERS THEN
          RAISE ex_serveis_no_trobats;
      END;
      
      IF v_num_resultats = 0 THEN
        RAISE ex_serveis_no_trobats;
      END IF;
      
      RSP := 'OK'; 
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_ACTUAL', 'RSP', 'S', RSP);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_ACTUAL', 'p_llista_serveis.COUNT', 'S', v_num_resultats); 
      COMMIT;

      EXCEPTION
      WHEN ex_serveis_no_trobats THEN
        RSP := 'ERROR-INFO_NO_TROBADA';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_ACTUAL', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_NO_DISPO_ACTUAL', 'RSP', 'S', RSP);
        COMMIT;
  
  END P_consultar_no_dispo_actual;

END PK_CONSULTES;

/
--------------------------------------------------------
--  DDL for Package Body PK_DATA_WAREHOUSE
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "MONITOR"."PK_DATA_WAREHOUSE" AS

  PROCEDURE P_calcular_disponibilitat(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER) AS
      
      v_crida_log NUMBER;  
      
  BEGIN
      
      --recalcula registres de monitorització amb resultat disponible
      UPDATE estadistiques SET registres_disponibles = NVL(registres_disponibles,0) + 1
      WHERE any_est = TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')) 
        AND  mes_est =  p_mes_est;
      
      --si no hi ha dades per el mes en curs, inicialitza les estadistiques
      IF SQL%ROWCOUNT = 0 THEN
        INSERT INTO estadistiques(ANY_EST ,MES_EST ,REGISTRES_DISPONIBLES)
        VALUES (TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')), p_mes_est, 1);
      END IF;
      
      RSP:='OK';
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_DISPONIBILITAT', 'RSP', 'S', RSP);
      
  EXCEPTION
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_DISPONIBILITAT', 'RSP', 'S', RSP);
        
  END P_calcular_disponibilitat;

  PROCEDURE P_calcular_no_disponibilitat(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER) AS
      
      v_crida_log NUMBER;
      
  BEGIN
        
       --recalcula registres de monitorització amb resultat no disponible
      UPDATE estadistiques SET registres_no_respon = NVL(registres_no_respon,0) + 1
      WHERE any_est = TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')) 
        AND  mes_est =  p_mes_est;
      
      --si no hi ha dades per el mes en curs, inicialitza les estadistiques
      IF SQL%ROWCOUNT = 0 THEN
        INSERT INTO estadistiques(ANY_EST ,MES_EST ,REGISTRES_NO_RESPON)
        VALUES (TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')), p_mes_est, 1);
      END IF;
      
      RSP:='OK';
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_NO_DISPONIBILITAT', 'RSP', 'S', RSP);
      
  EXCEPTION
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_NO_DISPONIBILITAT', 'RSP', 'S', RSP);
        
  END P_calcular_no_disponibilitat;

  PROCEDURE P_calcular_resp_no_esperada(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER) AS
      
      v_crida_log NUMBER;
      
  BEGIN
      --recalcula registres de monitorització amb resultat no disponible
      UPDATE estadistiques SET registres_no_resp_esp = NVL(registres_no_resp_esp,0) + 1
      WHERE any_est = TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')) 
        AND  mes_est =  p_mes_est;
      
      --si no hi ha dades per el mes en curs, inicialitza les estadistiques
      IF SQL%ROWCOUNT = 0 THEN
        INSERT INTO estadistiques(ANY_EST ,MES_EST ,REGISTRES_NO_RESP_ESP)
        VALUES (TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')), p_mes_est, 1);
      END IF;
      
      RSP:='OK';
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_RESP_NO_ESPERADA', 'RSP', 'S', RSP);
      
  EXCEPTION
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_RESP_NO_ESPERADA', 'RSP', 'S', RSP);
        
  END P_calcular_resp_no_esperada;

  PROCEDURE P_calcular_percentatges_dispo(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER) AS
      
      v_crida_log NUMBER;
      v_serv_alta_dispo NUMBER;
      v_serv_baixa_dispo NUMBER;
      
  BEGIN
        
      --obtenir el nombre de serveis amb disponibilitat major o igual al 95% i el que tenen menor disponibilitat total de 95%,
      --a partir del total de registres de monitorització del mes amb resultat de servei disponible, i calculat a partir del temps
      --en que el servei ha estat disponible i el temps en que el servei ha estat monitoritzat (segons l'interval d'execució de 
      --cada regla)
      
      FOR disponibilitat_rec IN (
      
        SELECT nivell_dispo, count(1) nombre_serveis  FROM (
          SELECT servei, percentatge_dispo, DECODE (SIGN(percentatge_dispo-95), -1, 'BAIXA', 'ALTA') nivell_dispo 
          FROM(
            SELECT servei, ROUND(SUM(temps_dispo)/SUM(temps_monitor)*100,2) percentatge_dispo  FROM (
              SELECT servei, regla, periode, registres_dispo, temps_dispo, temps_monitor
              FROM (
              SELECT regi.servei,regi.regla, regl.periode,regi.disponibilitat, COUNT(1) registres_dispo, COUNT(1)*regl.PERIODE temps_dispo,
                    (SELECT count(1) FROM registre_monitoritzacio regi2
                     WHERE regi.servei = regi2.servei
                      AND regi.regla = regi2.regla
                      AND regi2.data_hora >= TRUNC(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'),'MM')
                      AND TRUNC(regi2.data_hora) <= LAST_DAY(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'))) * regl.periode temps_monitor      
                    FROM registre_monitoritzacio regi, regla_monitoritzacio regl
                    WHERE regi.data_hora >= TRUNC(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'),'MM')
                      AND TRUNC(regi.data_hora) <= LAST_DAY(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'))
                      AND regi.disponibilitat = 'S'
                      AND regi.regla = regl.id        
                    GROUP BY regi.servei, regi.regla, regl.periode, regi.disponibilitat
              )
            )
            GROUP BY servei
          )
        )
        GROUP BY nivell_dispo)
          
      LOOP
          IF disponibilitat_rec.nivell_dispo = 'ALTA' THEN
            v_serv_alta_dispo := disponibilitat_rec.nombre_serveis;
          ELSE 
            v_serv_baixa_dispo := disponibilitat_rec.nombre_serveis;
          END IF;
          
      END LOOP;
      
      --actualitza el nombre de serveis per cada nivell de disponibilitat
      UPDATE estadistiques SET serveis_alta_dispo = v_serv_alta_dispo, 
                              serveis_baixa_dispo = v_serv_baixa_dispo
      WHERE any_est = TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')) 
        AND  mes_est =  p_mes_est;
       
      --si no hi ha dades per el mes en curs, inicialitza les estadistiques
      IF SQL%ROWCOUNT = 0 THEN
        INSERT INTO estadistiques(ANY_EST, MES_EST, SERVEIS_ALTA_DISPO, SERVEIS_BAIXA_DISPO)
        VALUES (TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')), p_mes_est, 0, 0);
      END IF;
      
      RSP:='OK';
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_PERCENTATGE_DISPO', 'RSP', 'S', RSP);
      
  EXCEPTION
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_PERCENTATGE_DISPO', 'RSP', 'S', RSP);
        
  END P_calcular_percentatges_dispo;

  PROCEDURE P_calcular_dia_menys_dispo(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER) AS
      
      v_crida_log NUMBER;
      v_dia_menys_dispo NUMBER;
      
  BEGIN
      --obtenir el dia amb menys disponibilitat global,
      --a partir del total de registres de monitorització del mes amb resultat de servei no disponible, i calculat a partir del temps
      --en que cada servei ha estat no disponible i el temps en que cada servei ha estat monitoritzat (segons l'interval d'execució de 
      --cada regla). Ordenam els dies de forma descendent segons el percentatge de no disponibilitat i llavors agafam el primer dia de la llista.
      FOR min_dia_rec IN (
      
        SELECT dia, ROUND(SUM(temps_no_dispo)/SUM(temps_monitor)*100,2) percentatge_no_dispo  FROM (
          SELECT TO_NUMBER(TO_CHAR(regi.data_hora,'DD')) dia, regi.servei, regi.regla, regl.periode, regi.disponibilitat
              , COUNT(1) registres_no_dispo
              , COUNT(1)*regl.PERIODE temps_no_dispo,              
              (SELECT count(1) FROM registre_monitoritzacio regi2
               WHERE regi.servei = regi2.servei
                AND regi.regla = regi2.regla
                AND regi2.data_hora >= TRUNC(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'),'MM')
                AND TRUNC(regi2.data_hora) <= LAST_DAY(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'))) * regl.periode temps_monitor      
          FROM registre_monitoritzacio regi, regla_monitoritzacio regl
          WHERE regi.data_hora >= TRUNC(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'),'MM')
            AND TRUNC(regi.data_hora) <= LAST_DAY(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'))
            AND regi.disponibilitat = 'N'
            AND regi.regla = regl.id        
          GROUP BY TO_CHAR(regi.data_hora,'DD'), regi.servei, regi.regla, regl.periode, regi.disponibilitat
        )
        GROUP BY dia
        ORDER BY percentatge_no_dispo desc)
        
      LOOP
          v_dia_menys_dispo := min_dia_rec.dia;
          EXIT;          
          
      END LOOP;
      
      --actualitza el nombre de serveis per cada nivell de disponibilitat
      UPDATE estadistiques SET dia_menys_dispo = v_dia_menys_dispo
      WHERE any_est = TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')) 
        AND  mes_est =  p_mes_est;
           
      RSP:='OK';
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_DIA_MENYS_DISPO', 'RSP', 'S', RSP);
      
  EXCEPTION
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_DIA_MENYS_DISPO', 'RSP', 'S', RSP);
        
  END P_calcular_dia_menys_dispo;

  PROCEDURE P_calcular_client_menys_dispo(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER) AS
      
      v_crida_log NUMBER;
      v_client_menys_dispo NUMBER;
      
  BEGIN
      --obtenir el client amb menys disponibilitat global,
      --a partir del total de registres de monitorització del mes amb resultat de servei no disponible, i calculat a partir del temps
      --en que cada servei ha estat no disponible i el temps en que cada servei ha estat monitoritzat (segons l'interval d'execució de 
      --cada regla). Ordenam els clients de forma descendent segons el percentatge de no disponibilitat i llavors agafam el primer client de la llista.
      FOR min_client_rec IN (
      
        SELECT client, ROUND(SUM(temps_no_dispo)/SUM(temps_monitor)*100,2) percentatge_no_dispo  FROM (
          SELECT servei, regla, periode, registres_no_dispo, temps_no_dispo, temps_monitor, client
          FROM (
            SELECT regi.servei,regi.regla, regl.periode,COUNT(1) registres_no_dispo, COUNT(1)*regl.PERIODE temps_no_dispo,
                  (SELECT count(1) FROM registre_monitoritzacio regi2
                   WHERE regi.servei = regi2.servei
                    AND regi.regla = regi2.regla
                    AND regi2.data_hora >= TRUNC(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'),'MM')
                    AND TRUNC(regi2.data_hora) <= LAST_DAY(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'))) * regl.periode temps_monitor,
                    sw.client
            FROM registre_monitoritzacio regi, regla_monitoritzacio regl, servei_web sw
            WHERE regi.data_hora >= TRUNC(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'),'MM')
              AND TRUNC(regi.data_hora) <= LAST_DAY(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'))
              AND regi.disponibilitat = 'N'
              AND regi.regla = regl.id        
              AND sw.id = regl.servei
            GROUP BY regi.servei, regi.regla, regl.periode, regi.disponibilitat, sw.client
          )
        )
        GROUP BY client
        ORDER BY percentatge_no_dispo desc)
        
      LOOP
          v_client_menys_dispo := min_client_rec.client;
          EXIT;          
          
      END LOOP;
      
      --actualitza el nombre de serveis per cada nivell de disponibilitat
      UPDATE estadistiques SET client_menys_dispo = v_client_menys_dispo
      WHERE any_est = TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')) 
        AND  mes_est =  p_mes_est;
        
      RSP:='OK';
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_CLIENT_MENYS_DISPO', 'RSP', 'S', RSP);
      
  EXCEPTION
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_CLIENT_MENYS_DISPO', 'RSP', 'S', RSP);
        
  END P_calcular_client_menys_dispo;

  PROCEDURE P_calcular_regla_mes_lenta(rsp OUT VARCHAR2, p_any_est NUMBER, p_mes_est NUMBER) AS
      
      v_crida_log NUMBER;
      v_regla_mes_lenta NUMBER;
      
  BEGIN
      
      --obtenir la regla de monitorització que més triga de mitjana,
      --a partir del total de registres de monitorització del mes amb resultat de servei disponible. 
      --Ordenam les regles de forma descendent segons la mitjana de temps que triguen i llavors agafam el primer client de la llista.
      FOR regla_rec IN (
      
        SELECT regla, sum(temps)/count(1) mitja_temps
        FROM registre_monitoritzacio 
        WHERE data_hora >= TRUNC(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'),'MM')
          AND TRUNC(data_hora) <= LAST_DAY(TO_DATE(P_MES_EST || '/' || p_any_est,'MM/RRRR'))
          AND disponibilitat = 'S'  
        GROUP BY regla
        ORDER BY mitja_temps desc)
        
      LOOP
          v_regla_mes_lenta := regla_rec.regla;
          EXIT;          
          
      END LOOP;
      
      --actualitza el nombre de serveis per cada nivell de disponibilitat
      UPDATE estadistiques SET regla_mes_lenta = v_regla_mes_lenta
      WHERE any_est = TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')) 
        AND  mes_est =  p_mes_est;
        
      RSP:='OK';
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_REGLA_MES_LENTA', 'RSP', 'S', RSP);
      
  EXCEPTION
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CALCULAR_REGLA_MES_LENTA', 'RSP', 'S', RSP);
        
  END P_calcular_regla_mes_lenta;

  PROCEDURE P_consultar_estadistiques(rsp OUT VARCHAR2, P_Registres_disponibles OUT NUMBER, P_Registres_no_respon OUT NUMBER, P_Registres_no_resp_esp OUT NUMBER,
                                      P_Serveis_alta_dispo OUT NUMBER, P_Serveis_baixa_dispo OUT NUMBER, P_Dia_menys_dispo OUT NUMBER, P_Client_menys_dispo OUT NUMBER, 
                                      P_Regla_mes_lenta OUT NUMBER, p_any_est NUMBER, p_mes_est NUMBER) AS
      
      v_crida_log NUMBER;
      ex_estadistica_no_trobada EXCEPTION;
      ex_data_no_valida EXCEPTION;
      v_data DATE;
      
  BEGIN
        
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'p_any_est', 'E', p_any_est);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'p_mes_est', 'E', p_mes_est);
            
      --valida que la data formada per el mes i any passats per paràmetre sigui vàlida
      BEGIN
        SELECT TO_DATE(p_mes_est||'/'||p_any_est, 'MM/RRRR') INTO v_data
        FROM DUAL;        
      EXCEPTION
        WHEN OTHERS THEN
          RAISE ex_data_no_valida;
      END;
      
      BEGIN
        SELECT registres_disponibles, registres_no_respon, registres_no_resp_esp, serveis_alta_dispo, serveis_baixa_dispo, dia_menys_dispo, client_menys_dispo, regla_mes_lenta
        INTO P_Registres_disponibles, P_Registres_no_respon, P_Registres_no_resp_esp, P_Serveis_alta_dispo, P_Serveis_baixa_dispo, P_Dia_menys_dispo, P_Client_menys_dispo, P_Regla_mes_lenta
         FROM estadistiques
         WHERE any_est = TO_NUMBER(TO_CHAR(TRUNC(TO_DATE(p_any_est,'RRRR'),'RRRR'),'RRRR')) 
        AND  mes_est =  p_mes_est
        ;
            
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_estadistica_no_trobada;
      END;
      
      RSP:='OK';
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'RSP', 'S', RSP);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'P_Registres_disponibles', 'S', P_Registres_disponibles);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'P_Registres_no_respon', 'S', P_Registres_no_respon);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'P_Registres_no_resp_esp', 'S', P_Registres_no_resp_esp);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'P_Serveis_alta_dispo', 'S', P_Serveis_alta_dispo);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'P_Serveis_baixa_dispo', 'S', P_Serveis_baixa_dispo);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'P_Dia_menys_dispo', 'S', P_Dia_menys_dispo);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'P_Client_menys_dispo', 'S', P_Client_menys_dispo);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'P_Regla_mes_lenta', 'S', P_Regla_mes_lenta);
      
  EXCEPTION
      WHEN ex_estadistica_no_trobada THEN
        RSP := 'ERROR-INFO_NO_TROBADA';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'RSP', 'S', RSP);
        
      WHEN ex_data_no_valida THEN
        RSP:= 'ERROR-DATA_NO_VALIDA';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'RSP', 'S', RSP);
      
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_ESTADISTIQUES', 'RSP', 'S', RSP);
        
  END P_consultar_estadistiques;

END PK_DATA_WAREHOUSE;

/
--------------------------------------------------------
--  DDL for Package Body PK_MANTENIMENT_MESTRES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "MONITOR"."PK_MANTENIMENT_MESTRES" AS

  PROCEDURE P_Crear_Client(rsp OUT VARCHAR2, p_id OUT VARCHAR2, p_nom VARCHAR2, p_cif VARCHAR2) AS
       
  BEGIN

    -- recupera el següent nombre de client de la seqüencia
    SELECT SEQ_CLIENT.NEXTVAL INTO p_id FROM DUAL;
    
    -- guarda el servei web
    INSERT INTO client (id, nom, cif) 
    VALUES (p_id, p_nom, p_cif);
    COMMIT;
    RSP := 'OK'; 
            
    EXCEPTION 
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        p_id := null;         
              
  END P_Crear_Client;
  
  PROCEDURE P_Modificar_Client(rsp OUT VARCHAR2, p_id VARCHAR2, p_nom VARCHAR2, p_cif VARCHAR2) AS
  
    v_id_client NUMBER;
    ex_client_no_existent  EXCEPTION;
    
  BEGIN
    
    --valida l'existencia del client
    BEGIN
      SELECT id INTO v_id_client FROM client where id = p_id;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RAISE ex_client_no_existent;
    END;

    -- modifica el servei web
    UPDATE client set nom = p_nom, cif = p_cif
    WHERE id = p_id;
    COMMIT;
    RSP := 'OK'; 
            
    EXCEPTION 
      
      WHEN ex_client_no_existent THEN
        RSP := 'ERROR-CLIENT_NO_EXISTEIX';      
      
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
  
  END P_Modificar_Client;
  
  PROCEDURE P_Eliminar_Client(rsp OUT VARCHAR2, p_id VARCHAR2) AS
  
    v_id_client NUMBER;
    v_num_serveis NUMBER;
    ex_serveis_assoc EXCEPTION;
    ex_client_no_existent  EXCEPTION;
    
  BEGIN
    
    --valida l'existencia del client
    BEGIN
      SELECT id INTO v_id_client FROM client where id = p_id;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RAISE ex_client_no_existent;
    END;
    
    --valida si el client té serveis web associats
    BEGIN
      SELECT COUNT(1) INTO v_num_serveis FROM servei_web where client = p_id;
      IF v_num_serveis > 0 THEN
        RAISE ex_serveis_assoc;
      END IF;
    END;

    -- esborra el client
    DELETE FROM client
    WHERE id = p_id;
    COMMIT;
    
    RSP := 'OK';
    
    EXCEPTION 
      
      WHEN ex_client_no_existent THEN
        RSP := 'ERROR-CLIENT_NO_EXISTEIX';      
      
      WHEN ex_serveis_assoc THEN
        RSP := 'ERROR-SERVEIS_ASSOCIATS';      
               
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
  
  END P_Eliminar_Client;

  PROCEDURE P_Crear_Tipus_Servei(rsp OUT VARCHAR2, p_codi VARCHAR2, p_descripcio VARCHAR2) AS
  BEGIN
    
    -- guarda el tipus de servei
    INSERT INTO tipus_servei (codi, descripcio) 
    VALUES (p_codi, p_descripcio);
    COMMIT;
    RSP := 'OK'; 
            
    EXCEPTION 
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        
  END P_Crear_Tipus_Servei;

  PROCEDURE P_Modificar_Tipus_Servei(rsp OUT VARCHAR2, p_codi VARCHAR2, p_descripcio VARCHAR2) AS
  
    v_codi VARCHAR2(10);
    ex_tipus_no_existent  EXCEPTION;
    
  BEGIN
    
    --valida l'existencia del tipus de servei
    BEGIN
      SELECT codi INTO v_codi FROM tipus_servei where codi = p_codi;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RAISE ex_tipus_no_existent;
    END;

    -- modifica el tipus de servei
    UPDATE tipus_servei set descripcio = p_descripcio
    WHERE codi = p_codi;
    COMMIT;
    RSP := 'OK'; 
            
    EXCEPTION 
      
      WHEN ex_tipus_no_existent THEN
        RSP := 'ERROR-TIPUS_NO_EXISTEIX';      
      
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        
  END P_Modificar_Tipus_Servei;

  PROCEDURE P_Eliminar_Tipus_Servei(rsp OUT VARCHAR2, p_codi VARCHAR2) AS
  
    v_tipus VARCHAR2(10);
    v_num_serveis NUMBER;
    ex_serveis_assoc EXCEPTION;
    ex_tipus_no_existent  EXCEPTION;
    
  BEGIN
    
    --valida l'existencia del tipus de servei
    BEGIN
      SELECT codi INTO v_tipus FROM tipus_servei where codi = p_codi;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RAISE ex_tipus_no_existent;
    END;
    
    --valida si el tipus té serveis web associats
    BEGIN
      SELECT COUNT(1) INTO v_num_serveis FROM servei_web where tipus = p_codi;
      IF v_num_serveis > 0 THEN
        RAISE ex_serveis_assoc;
      END IF;
    END;

    -- esborra el tipus de servei
    DELETE FROM tipus_servei
    WHERE codi = p_codi;
    COMMIT;
    
    RSP := 'OK';
    
    EXCEPTION 
      
      WHEN ex_tipus_no_existent THEN
        RSP := 'ERROR-TIPUS_NO_EXISTEIX';      
      
      WHEN ex_serveis_assoc THEN
        RSP := 'ERROR-SERVEIS_ASSOCIATS';      
               
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
  
  END P_Eliminar_Tipus_Servei;

  PROCEDURE P_Crear_Tipus_Error(rsp OUT VARCHAR2, p_codi VARCHAR2, p_descripcio VARCHAR2) AS
  BEGIN
    
    -- guarda el tipus de error
    INSERT INTO tipus_error (codi, descripcio) 
    VALUES (p_codi, p_descripcio);
    COMMIT;
    RSP := 'OK'; 
            
    EXCEPTION 
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        
  END P_Crear_Tipus_Error;

  PROCEDURE P_Modificar_Tipus_Error(rsp OUT VARCHAR2, p_codi VARCHAR2, p_descripcio VARCHAR2) AS
  
    v_codi VARCHAR2(10);
    ex_tipus_no_existent  EXCEPTION;
    
  BEGIN
    
    --valida l'existencia del tipus d'error
    BEGIN
      SELECT codi INTO v_codi FROM tipus_error where codi = p_codi;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RAISE ex_tipus_no_existent;
    END;

    -- modifica el tipus d'error
    UPDATE tipus_error set descripcio = p_descripcio
    WHERE codi = p_codi;
    COMMIT;
    RSP := 'OK'; 
            
    EXCEPTION 
      
      WHEN ex_tipus_no_existent THEN
        RSP := 'ERROR-TIPUS_NO_EXISTEIX';      
      
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        
  END P_Modificar_Tipus_Error;

  PROCEDURE P_Eliminar_Tipus_Error(rsp OUT VARCHAR2, p_codi VARCHAR2) AS
  
    v_tipus VARCHAR2(10);
    v_num_registres NUMBER;
    ex_registres_assoc EXCEPTION;
    ex_tipus_no_existent  EXCEPTION;
    
  BEGIN
    
    --valida l'existencia del tipus d'error
    BEGIN
      SELECT codi INTO v_tipus FROM tipus_error where codi = p_codi;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        RAISE ex_tipus_no_existent;
    END;
    
    --valida si el tipus té registres de monitoritzacio associats
    BEGIN
      SELECT COUNT(1) INTO v_num_registres FROM registre_monitoritzacio where error = p_codi;
      IF v_num_registres > 0 THEN
        RAISE ex_registres_assoc;
      END IF;
    END;

    -- esborra el tipus d'error
    DELETE FROM tipus_error
    WHERE codi = p_codi;
    COMMIT;
    
    RSP := 'OK';
    
    EXCEPTION 
      
      WHEN ex_tipus_no_existent THEN
        RSP := 'ERROR-TIPUS_NO_EXISTEIX';      
      
      WHEN ex_registres_assoc THEN
        RSP := 'ERROR-REGISTRES_ASSOCIATS';      
               
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
  
    END P_Eliminar_Tipus_Error;

END PK_MANTENIMENT_MESTRES;

/
--------------------------------------------------------
--  DDL for Package Body PK_MANTENIMENT_REGISTRES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "MONITOR"."PK_MANTENIMENT_REGISTRES" AS

  PROCEDURE P_crear_registre(rsp OUT VARCHAR2, p_id OUT NUMBER, P_Servei VARCHAR2, P_Regla NUMBER, P_Pas_darrer NUMBER,
                                            P_Temps NUMBER, P_Error VARCHAR2, P_DataHora DATE) AS
                                            
      v_servei VARCHAR2(10);
      v_regla NUMBER;
      v_pas NUMBER;
      v_ordre NUMBER;
      v_ordre_max NUMBER;
      v_error VARCHAR2(1);
      v_crida_log NUMBER;
      ex_regla_no_existent EXCEPTION;
      ex_pas_no_existent EXCEPTION;
      ex_servei_no_existent EXCEPTION;
      v_any_est NUMBER;
      v_mes_est NUMBER;
      
  BEGIN
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'P_Servei', 'E', P_Servei);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'P_Regla', 'E', P_Regla);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'P_Pas_darrer', 'E', P_Pas_darrer);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'P_Temps', 'E', P_Temps);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'P_Error', 'E', P_Error);
      COMMIT;
      
      -- valida que el serveix existeix
      BEGIN
        SELECT id INTO v_servei FROM servei_web where id = p_servei;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_servei_no_existent;
      END;
      
      --valida l'existencia de la regla
      BEGIN
        SELECT id INTO v_regla FROM regla_monitoritzacio 
        WHERE id = p_regla;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_regla_no_existent;
      END;
      
      -- valida que el pas existeix
      BEGIN
        SELECT ordre INTO v_ordre FROM pas_monitoritzacio 
        WHERE id = P_Pas_darrer;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_pas_no_existent;
      END;
      
      -- comprova que el darrer pas executat es el darrer de la regla
      SELECT MAX(ordre) into v_ordre_max FROM pas_monitoritzacio
        WHERE regla = p_regla;
      
      IF v_ordre_max > v_ordre OR p_error IS NOT NULL THEN
        v_error := 'S';
      END IF;
      
      -- recupera el següent codi de la seqüencia
      SELECT SEQ_REGISTRE.NEXTVAL INTO p_id FROM DUAL;
      
      -- guarda registre
      IF P_DataHora IS NULL THEN
        INSERT INTO REGISTRE_MONITORITZACIO (id, servei, regla, pas_darrer, temps, disponibilitat, error)
          VALUES (p_id, p_servei, p_regla, p_pas_darrer, DECODE(v_error, 'S', 0, p_temps), DECODE(v_error, 'S', 'N', 'S'), p_error);
          
          v_any_est := TO_NUMBER(TO_CHAR(TRUNC(SYSDATE,'RRRR'),'RRRR'));
          v_mes_est := TO_NUMBER(TO_CHAR(TRUNC(SYSDATE,'MM'),'MM'));
            
      ELSE
        INSERT INTO REGISTRE_MONITORITZACIO (id, data_hora, servei, regla, pas_darrer, temps, disponibilitat, error)
          VALUES (p_id, p_DataHora, p_servei, p_regla, p_pas_darrer, DECODE(v_error, 'S', 0, p_temps), DECODE(v_error, 'S', 'N', 'S'), p_error);
          
          v_any_est := TO_NUMBER(TO_CHAR(TRUNC(p_DataHora,'RRRR'),'RRRR'));
          v_mes_est := TO_NUMBER(TO_CHAR(TRUNC(p_DataHora,'MM'),'MM'));
          
      END IF;
      IF p_error IS NULL THEN
        PK_DATA_WAREHOUSE.P_calcular_disponibilitat(rsp, v_any_est, v_mes_est); 
      ELSE 
        IF p_error = 'NORESPON' THEN
          PK_DATA_WAREHOUSE.P_calcular_no_disponibilitat(rsp, v_any_est, v_mes_est);
        ELSE
          PK_DATA_WAREHOUSE.P_calcular_resp_no_esperada(rsp, v_any_est, v_mes_est);
        END IF;
      END IF; 
      
      PK_DATA_WAREHOUSE.P_calcular_percentatges_dispo(rsp, v_any_est, v_mes_est);
      PK_DATA_WAREHOUSE.P_calcular_dia_menys_dispo(rsp, v_any_est, v_mes_est);
      PK_DATA_WAREHOUSE.P_calcular_client_menys_dispo(rsp, v_any_est, v_mes_est);
      PK_DATA_WAREHOUSE.P_calcular_regla_mes_lenta(rsp, v_any_est, v_mes_est);
      
      RSP := 'OK';
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'RSP', 'S', RSP);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'p_id', 'S', p_id);
      COMMIT;
      
      EXCEPTION
      
      WHEN ex_servei_no_existent THEN
        RSP := 'ERROR-SERVEI_NO_EXISTEIX';
        ROLLBACK;
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN ex_regla_no_existent THEN
        RSP := 'ERROR-REGLA_NO_EXISTEIX';
        ROLLBACK;
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN ex_pas_no_existent THEN
        RSP := 'ERROR-PAS_NO_EXISTEIX';
        ROLLBACK;
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        p_id := null;
        ROLLBACK;
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGISTRE', 'RSP', 'S', RSP);
        COMMIT;
      
  END P_crear_registre;

  PROCEDURE P_eliminar_registres(rsp OUT VARCHAR2) AS
  
      v_crida_log NUMBER;
      ex_no_registres EXCEPTION;
      
  BEGIN
      -- esborra els registres 
      BEGIN
        DELETE FROM REGISTRE_MONITORITZACIO
        WHERE DATA_HORA < TRUNC(SYSDATE,'YYYY')-1;
      EXCEPTION WHEN NO_DATA_FOUND THEN
        RAISE ex_no_registres;
      END;
      
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ELIMINAR_REGISTRES', 'RSP', 'S', RSP);
      
      COMMIT;
      RSP := 'OK';
      
      EXCEPTION
      
        WHEN ex_no_registres THEN
          RSP := 'ERROR-NO_REGISTRES';
          INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
            VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ELIMINAR_REGISTRES', 'RSP', 'S', RSP);
          COMMIT;
          
        WHEN OTHERS THEN
           RSP := 'ERROR-' || SQLERRM; 
          INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
            VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ELIMINAR_REGISTRES', 'RSP', 'S', RSP);
          COMMIT;
          
  END P_eliminar_registres;

END PK_MANTENIMENT_REGISTRES;

/
--------------------------------------------------------
--  DDL for Package Body PK_MANTENIMENT_REGLES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "MONITOR"."PK_MANTENIMENT_REGLES" AS

  PROCEDURE P_crear_regla(rsp OUT VARCHAR2, p_id OUT NUMBER, p_nom VARCHAR2, p_periode NUMBER, p_servei VARCHAR2) AS
      ex_servei_no_existent EXCEPTION;
      v_id_servei VARCHAR2(10);
      v_regla_activa NUMBER;
      v_rsp VARCHAR2(500);
      v_crida_log NUMBER;
      
  BEGIN
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGLA', 'p_nom', 'E', p_nom);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGLA', 'p_periode', 'E', p_periode);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGLA', 'p_servei', 'E', p_servei);
      
      COMMIT;
      
      --valida l'existencia del servei
      BEGIN
        SELECT id INTO v_id_servei FROM servei_web where id = p_servei;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_servei_no_existent;
      END;

      --desactiva una regla diferent ja activa si existeix
      BEGIN
        SELECT id INTO v_regla_activa FROM regla_monitoritzacio
        WHERE activa = 'S'
          AND servei = p_servei;
        
        P_desactivar_regla(v_rsp, v_regla_activa);
        
      EXCEPTION WHEN OTHERS THEN 
        NULL;
      END;

      -- recupera el següent codi de la seqüencia
      SELECT SEQ_REGLA.NEXTVAL INTO p_id FROM DUAL;
      
      -- guarda la regla
      INSERT INTO regla_monitoritzacio (id, nom, periode, servei, activa) 
        VALUES (P_id, p_nom, p_periode, p_servei, 'S');

      -- guarda d'historic
      INSERT INTO regles_historiques (regla, ordre, activa)
        SELECT p_id, NVL(MAX(ordre),0)+1,'S' FROM regles_historiques
        WHERE regla = p_id;

      RSP := 'OK'; 
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGLA', 'RSP', 'S', RSP);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGLA', 'p_id', 'S', p_id);
      
      COMMIT;
      
  EXCEPTION
      
      WHEN ex_servei_no_existent THEN
        RSP := 'ERROR-SERVEI_NO_EXISTEIX';
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN OTHERS THEN
         RSP := 'ERROR-' || SQLERRM; 
         p_id := null;
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_REGLA', 'RSP', 'S', RSP);
          
        COMMIT;
         
  END P_crear_regla;

  PROCEDURE P_desactivar_regla(rsp OUT VARCHAR2, p_id VARCHAR2) AS
      
      v_activa VARCHAR2(1);
      v_crida_log NUMBER;
      ex_regla_no_existent EXCEPTION;
      ex_regla_activa EXCEPTION;
      
    BEGIN 
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_DESACTIVAR_REGLA', 'p_id', 'E', p_id);
      COMMIT;
      
      --valida l'existencia de la regla
      BEGIN
        SELECT activa INTO v_activa FROM regla_monitoritzacio 
        WHERE id = p_id;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_regla_no_existent;
      END;
      
      --valida si la regla es troba desactivada
      IF v_activa = 'N' THEN
        RAISE ex_regla_activa;
      END IF;
      
      -- actualitza la regla com a no activa
      UPDATE regla_monitoritzacio set activa = 'N'
      WHERE ID = p_id;
      
      -- guarda d'historic
      INSERT INTO regles_historiques (regla, ordre, activa)
        SELECT p_id, NVL(MAX(ordre),0)+1,'N' FROM regles_historiques
        WHERE regla = p_id;
        
      RSP := 'OK'; 
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_DESACTIVAR_REGLA', 'RSP', 'S', RSP);
      COMMIT;
      
    EXCEPTION
      
      WHEN ex_regla_no_existent THEN
        RSP := 'ERROR-ID_NO_EXISTEIX'; 
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_DESACTIVAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN ex_regla_activa THEN
        RSP := 'ERROR-REGLA_NO_ACTIVA'; 
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_DESACTIVAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN OTHERS THEN
         RSP := 'ERROR-' || SQLERRM; 
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_DESACTIVAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;
      
  END P_desactivar_regla;

  PROCEDURE P_activar_regla(rsp OUT VARCHAR2, p_id NUMBER) AS
      v_activa VARCHAR2(1);
      v_servei VARCHAR2(10);
      v_regla_activa NUMBER;      
      v_rsp VARCHAR2(500);
      v_crida_log NUMBER;
      ex_regla_no_existent EXCEPTION;
      ex_regla_activa EXCEPTION;
      
    BEGIN 
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ACTIVAR_REGLA', 'p_id', 'E', p_id);
      COMMIT;
      
      --valida l'existencia de la regla
      BEGIN
        SELECT activa, servei INTO v_activa, v_servei FROM regla_monitoritzacio 
        WHERE id = p_id;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_regla_no_existent;
      END;
      
      --valida si la regla es troba desactivada
      IF v_activa = 'S' THEN
        RAISE ex_regla_activa;
      END IF;
      
      --desactiva una regla diferent ja activa
      BEGIN
        SELECT id INTO v_regla_activa FROM regla_monitoritzacio
        WHERE activa = 'S'
          AND servei = v_servei;
        
        P_desactivar_regla(v_rsp, v_regla_activa);
        
      EXCEPTION WHEN OTHERS THEN 
        NULL;
      END;
      
      -- actualitza la regla com activa
      UPDATE regla_monitoritzacio set activa = 'S'
      WHERE ID = p_id;
      
      -- guarda d'historic
      INSERT INTO regles_historiques (regla, ordre, activa)
        SELECT p_id, NVL(MAX(ordre),0)+1,'S' FROM regles_historiques
        WHERE regla = p_id;
        
      RSP := 'OK';
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ACTIVAR_REGLA', 'RSP', 'S', RSP);
      COMMIT; 
      
    EXCEPTION
      
      WHEN ex_regla_no_existent THEN
        RSP := 'ERROR-ID_NO_EXISTEIX';
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ACTIVAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN ex_regla_activa THEN
        RSP := 'ERROR-REGLA_ACTIVA';
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ACTIVAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN OTHERS THEN
         RSP := 'ERROR-' || SQLERRM; 
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ACTIVAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;
         
  END P_activar_regla;

  PROCEDURE P_modificar_regla(rsp OUT VARCHAR2, p_id NUMBER, p_nom VARCHAR2, p_periode NUMBER, p_servei VARCHAR2) AS
      ex_servei_no_existent EXCEPTION;
      ex_regla_no_existent EXCEPTION;
      v_activa VARCHAR2(1);
      v_id_servei VARCHAR2(10);
      v_regla_activa NUMBER;
      v_rsp VARCHAR2(500);
      v_crida_log NUMBER;
      
  BEGIN
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_REGLA', 'p_id', 'E', p_id);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_REGLA', 'p_nom', 'E', p_nom);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_REGLA', 'p_periode', 'E', p_periode);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_REGLA', 'p_servei', 'E', p_servei);
      COMMIT;
      
      --valida l'existencia de la regla
      BEGIN
        SELECT activa INTO v_activa FROM regla_monitoritzacio 
        WHERE id = p_id;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_regla_no_existent;
      END;
      
      --valida l'existencia del servei
      IF  p_servei IS NOT NULL THEN
        BEGIN
          SELECT id INTO v_id_servei FROM servei_web where id = p_servei;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN
            RAISE ex_servei_no_existent;
        END;
      END IF;
      
      -- modifica la regla
      UPDATE regla_monitoritzacio 
      SET nom = NVL(p_nom, nom)
		, periode = NVL(p_periode, periode)
        , servei = NVL(p_servei, servei)
      WHERE ID = p_id;
      
      RSP := 'OK'; 
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_REGLA', 'RSP', 'S', RSP);
      COMMIT; 
      
  EXCEPTION      
      WHEN ex_regla_no_existent THEN
        RSP := 'ERROR-ID_NO_EXISTEIX';
         
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN ex_servei_no_existent THEN
        RSP := 'ERROR-SERVEI_NO_EXISTEIX';
         
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN OTHERS THEN
         RSP := 'ERROR-' || SQLERRM; 
         
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_REGLA', 'RSP', 'S', RSP);
        COMMIT;

  END P_modificar_regla;
    
  PROCEDURE P_crear_pas(rsp OUT VARCHAR2, p_id OUT NUMBER, p_descripcio VARCHAR2, P_ordre NUMBER, P_url VARCHAR2,
                        p_timeout NUMBER, p_peticio VARCHAR2, p_resposta VARCHAR2, p_regla NUMBER) AS
      v_regla NUMBER;
      v_pas NUMBER;
      ex_regla_no_existent EXCEPTION;
      ex_ordre_repetit EXCEPTION;
      v_crida_log NUMBER;
      
    BEGIN 
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'p_descripcio', 'E', p_descripcio);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'P_ordre', 'E', P_ordre);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'P_url', 'E', P_url);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'p_timeout', 'E', p_timeout);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'p_peticio', 'E', p_peticio);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'p_resposta', 'E', p_resposta);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'p_regla', 'E', p_regla);
      COMMIT;
      
      --valida l'existencia de la regla
      BEGIN
        SELECT id INTO v_regla FROM regla_monitoritzacio 
        WHERE id = p_regla;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_regla_no_existent;
      END;
      
      --valida ordre correcte
      BEGIN
        SELECT id INTO v_pas FROM pas_monitoritzacio 
        WHERE regla = p_regla
          AND ordre = p_ordre;
        
        RAISE ex_ordre_repetit; 
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          NULL;
      END;
      
      -- recupera el següent codi de la seqüencia
      SELECT SEQ_PAS.NEXTVAL INTO p_id FROM DUAL;
      
      --guarda el nou pas
      INSERT INTO pas_monitoritzacio (id, descripcio, ordre, url, timeout, peticio, resposta, regla)
        VALUES (p_id, p_descripcio, p_ordre, p_url, p_timeout, p_peticio, p_resposta, p_regla);
        
      RSP := 'OK';
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'RSP', 'S', RSP);
      COMMIT;
      
    EXCEPTION      
      WHEN ex_regla_no_existent THEN
        RSP := 'ERROR-REGLA_NO_EXISTEIX';
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN ex_ordre_repetit THEN
        RSP := 'ERROR-ORDRE_REPETIT';
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN OTHERS THEN
         RSP := 'ERROR-' || SQLERRM; 
         p_id := null;
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_PAS', 'RSP', 'S', RSP);
        COMMIT;
      
  END P_crear_pas;

  PROCEDURE P_eliminar_pas(rsp OUT VARCHAR2, p_id NUMBER) AS
      v_ordre NUMBER;
      v_regla NUMBER;
      ex_pas_no_existent EXCEPTION;
      v_rsp VARCHAR2(200);
      v_crida_log NUMBER;
      
    BEGIN 
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ELIMINAR_PAS', 'p_id', 'E', p_id);
      COMMIT;
      
      --valida l'existencia del pas
      BEGIN
        SELECT ordre, regla INTO v_ordre, v_regla FROM pas_monitoritzacio 
        WHERE id = p_id;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_pas_no_existent;
      END;
      
      --esborra el pas
      DELETE FROM pas_monitoritzacio
      WHERE id = p_id;
      
      --recalcula l'order dels passos restants
      FOR rec IN (SELECT id, ordre
                  FROM pas_monitoritzacio
                  WHERE ordre > v_ordre
                    AND regla = v_regla
                  ORDER BY ordre)
      LOOP
        P_modificar_pas(v_rsp, rec.id, NULL, rec.ordre-1, NULL, NULL, NULL, NULL);
      END LOOP;
        
      RSP := 'OK';      
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ELIMINAR_PAS', 'RSP', 'S', RSP);
      COMMIT;
      
    EXCEPTION      
      WHEN ex_pas_no_existent THEN
        RSP := 'ERROR-ID_NO_EXISTEIX';
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ELIMINAR_PAS', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN OTHERS THEN
         RSP := 'ERROR-' || SQLERRM; 
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_ELIMINAR_PAS', 'RSP', 'S', RSP);
        COMMIT;
      
  END P_eliminar_pas;

  PROCEDURE P_modificar_pas(rsp OUT VARCHAR2, p_id NUMBER, p_descripcio VARCHAR2, P_ordre NUMBER, P_url VARCHAR2,
                            p_timeout NUMBER, p_peticio VARCHAR2, p_resposta VARCHAR2) AS
      v_pas NUMBER;
      v_regla NUMBER;
      ex_ordre_repetit EXCEPTION;
      ex_pas_no_existent EXCEPTION;
      v_crida_log NUMBER;
      
    BEGIN 
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'p_id', 'E', p_id);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'p_descripcio', 'E', p_descripcio);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'P_ordre', 'E', P_ordre);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'P_url', 'E', P_url);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'p_timeout', 'E', p_timeout);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'p_peticio', 'E', p_peticio);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'p_resposta', 'E', p_resposta);
      COMMIT;
      
      --valida l'existencia del pas
      BEGIN
        SELECT regla INTO v_regla FROM pas_monitoritzacio 
        WHERE id = p_id;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_pas_no_existent;
      END;
      
      --valida ordre correcte
      BEGIN
        SELECT id INTO v_pas FROM pas_monitoritzacio 
        WHERE regla = v_regla
          AND ordre = p_ordre
		  AND id <> p_id;
        
        RAISE ex_ordre_repetit; 
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          NULL;
      END;
      
      --modifica el pas
      UPDATE pas_monitoritzacio 
      SET descripcio = NVL(p_descripcio, descripcio)
        , ordre = NVL(p_ordre, ordre)
        , url = NVL(p_url, url)
        , timeout = NVL(p_timeout, timeout)
        , peticio = NVL(p_peticio, peticio)
        , resposta = NVL(p_resposta, resposta)        
      WHERE ID = p_id; 
        
      RSP := 'OK';        
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'RSP', 'S', RSP);
      COMMIT;
      
    EXCEPTION      
      WHEN ex_pas_no_existent THEN
        RSP := 'ERROR-ID_NO_EXISTEIX';
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN ex_ordre_repetit THEN
        RSP := 'ERROR-ORDRE_REPETIT';
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN OTHERS THEN
         RSP := 'ERROR-' || SQLERRM; 
        
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_PAS', 'RSP', 'S', RSP);
        COMMIT;
      
  END P_modificar_pas;

END PK_MANTENIMENT_REGLES;

/
--------------------------------------------------------
--  DDL for Package Body PK_MANTENIMENT_SERVEIS_WEB
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "MONITOR"."PK_MANTENIMENT_SERVEIS_WEB" AS 

   PROCEDURE P_crear_servei_web(rsp OUT VARCHAR2, p_id VARCHAR2, p_descripcio VARCHAR2, p_tipus VARCHAR2, p_url VARCHAR2, p_client NUMBER) AS
   
      ex_id_no_valid  EXCEPTION;
      ex_client_no_existent  EXCEPTION;
      ex_tipus_no_existent  EXCEPTION;
      v_id_client NUMBER;
      v_codi_tipus VARCHAR2(10);
      v_crida_log NUMBER;
      
    BEGIN 
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_SERVEI_WEB', 'p_id', 'E', p_id);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_SERVEI_WEB', 'p_descripcio', 'E', p_descripcio);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_SERVEI_WEB', 'p_tipus', 'E', p_tipus);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_SERVEI_WEB', 'p_url', 'E', p_url);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_SERVEI_WEB', 'p_client', 'E', p_client);
      COMMIT;
      
      -- valida la longitud de l'indentificador
      IF LENGTH(p_id) >10 THEN
        RAISE ex_id_no_valid;
      END IF;
      
      --valida l'existencia del client
      BEGIN
        SELECT id INTO v_id_client FROM client where id = p_client;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_client_no_existent;
      END;
      
      --valida l'existencia del tipus de servei
      BEGIN
        
        SELECT codi INTO v_codi_tipus FROM tipus_servei where codi = p_tipus;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_tipus_no_existent;
      END;
      
      --guarda el servei web
      INSERT INTO servei_web (id, descripcio, tipus, url, client, actiu) 
      VALUES (p_id, p_descripcio, p_tipus, p_url, p_client, 'S');
      
      RSP := 'OK'; 
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_SERVEI_WEB', 'RSP', 'S', RSP);
      COMMIT;
        
    EXCEPTION
      WHEN ex_id_no_valid THEN
        RSP := 'ERROR-ID_NO_VALID';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN ex_client_no_existent THEN
        RSP := 'ERROR-CLIENT_NO_EXISTEIX';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN ex_tipus_no_existent THEN
        RSP := 'ERROR-TIPUS_NO_EXISTEIX';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CREAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 

        
    END P_crear_servei_web;
    
      
    PROCEDURE P_donar_de_baixa_servei_web(rsp OUT VARCHAR2, p_id VARCHAR2)AS
  
      v_id_servei VARCHAR2(10);
      ex_servei_no_existent EXCEPTION;
      v_crida_log NUMBER;
      
    BEGIN 
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_DONAR_DE_BAIXA_SERVEI_WEB', 'p_id', 'E', p_id);
      COMMIT;
      
      --valida l'existencia del servei
      BEGIN
        SELECT id INTO v_id_servei FROM servei_web where id = p_id;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_servei_no_existent;
      END;
      
      -- actualitza el servei com a no actiu
      UPDATE servei_web set actiu = 'N'
      WHERE ID = p_id;
      
      RSP := 'OK';  
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_DONAR_DE_BAIXA_SERVEI_WEB', 'RSP', 'S', RSP);
      COMMIT;
      
    EXCEPTION
      
      WHEN ex_servei_no_existent THEN
        RSP := 'ERROR-ID_NO_EXISTENT';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_DONAR_DE_BAIXA_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_DONAR_DE_BAIXA_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
         
    END P_donar_de_baixa_servei_web;
    
    PROCEDURE P_modificar_servei_web(rsp OUT VARCHAR2, p_id VARCHAR2, p_descripcio VARCHAR2, p_tipus VARCHAR2, p_url VARCHAR2, p_client NUMBER) AS
   
      ex_id_no_existent  EXCEPTION;
      ex_client_no_existent  EXCEPTION;
      ex_tipus_no_existent  EXCEPTION;
      v_id_client NUMBER;
      v_codi_tipus VARCHAR2(10);
      v_id_servei VARCHAR2(10);
      v_crida_log NUMBER;
      
    BEGIN 
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'p_id', 'E', p_id);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'p_descripcio', 'E', p_descripcio);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'p_tipus', 'E', p_tipus);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'p_url', 'E', p_url);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'p_client', 'E', p_client);
      COMMIT;
      
      -- valida l'existencia del servei
      BEGIN
        SELECT id INTO v_id_servei FROM servei_web where id = p_id;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_id_no_existent;
      END;
      
      --valida l'existencia del client
      BEGIN
        SELECT id INTO v_id_client FROM client where id = p_client;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_client_no_existent;
      END;
      
      --valida l'existencia del tipus de servei
      BEGIN
        SELECT codi INTO v_codi_tipus FROM tipus_servei where codi = p_tipus;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_tipus_no_existent;
      END;
      
      --modifica el servei web
      UPDATE servei_web 
      SET descripcio = p_descripcio
        , tipus = p_tipus
        , url = p_url
        , client = p_client
      WHERE ID = p_id;
      
      RSP := 'OK';  
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'RSP', 'S', RSP);
      COMMIT;
        
    EXCEPTION
      WHEN ex_id_no_existent THEN
        RSP := 'ERROR-ID_NO_EXISTENT';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN ex_client_no_existent THEN
        RSP := 'ERROR-CLIENT_NO_EXISTEIX';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN ex_tipus_no_existent THEN
        RSP := 'ERROR-TIPUS_NO_EXISTEIX';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_MODIFICAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;

        
    END P_modificar_servei_web;
    
    
    PROCEDURE P_consultar_servei_web(rsp OUT VARCHAR2, Llista_serveis OUT T_Servei_Web, p_id VARCHAR2, p_tipus VARCHAR2, p_client NUMBER, p_actiu VARCHAR2) AS
    
      t_llista_serveis T_Servei_Web;
      ex_client_no_existent  EXCEPTION;
      ex_tipus_no_existent  EXCEPTION;
      ex_serveis_no_trobats EXCEPTION;
      v_id_client NUMBER;
      v_codi_tipus VARCHAR2(10);
      v_crida_log NUMBER;
      v_num_resultats NUMBER;
      
    BEGIN
      -- guarda la crida al log
      SELECT SEQ_CRIDA.NEXTVAL INTO v_crida_log FROM DUAL;
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'p_id', 'E', p_id);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'p_tipus', 'E', p_tipus);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'p_actiu', 'E', p_actiu);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'p_client', 'E', p_client);
      COMMIT;
      
      --valida l'existencia del client
      BEGIN
        IF p_client IS NOT NULL THEN
          SELECT id INTO v_id_client FROM client where id = p_client;
        END IF;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_client_no_existent;
      END;
      
      --valida l'existencia del tipus de servei
      BEGIN
        IF p_tipus IS NOT NULL THEN
          SELECT codi INTO v_codi_tipus FROM tipus_servei where codi = p_tipus;
        END IF;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_tipus_no_existent;
      END;
      
      BEGIN
        SELECT *
         BULK COLLECT INTO t_llista_serveis 
         FROM servei_web
         WHERE id = nvl(p_id,id) 
            AND tipus = nvl(p_tipus, tipus)
            AND client = nvl(p_client, client)
            AND actiu = nvl(p_actiu,actiu);
            
        Llista_serveis := t_llista_serveis;
      
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          RAISE ex_serveis_no_trobats;
      END;
      
      v_num_resultats := t_llista_serveis.COUNT;
      RSP := 'OK'; 
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'RSP', 'S', RSP);
      INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
        VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'Llista_serveis.COUNT', 'S', v_num_resultats); 
      COMMIT;
      
    EXCEPTION
      WHEN ex_serveis_no_trobats THEN
        RSP := 'ERROR-SERVEIS_NO_TROBATS';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
        
      WHEN ex_client_no_existent THEN
        RSP := 'ERROR-CLIENT_NO_EXISTEIX';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN ex_tipus_no_existent THEN
        RSP := 'ERROR-TIPUS_NO_EXISTEIX';
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
      
      WHEN OTHERS THEN
        RSP := 'ERROR-' || SQLERRM; 
        INSERT INTO log (id, crida, procediment, parametre, tipus_parametre, valor_parametre) 
          VALUES (SEQ_LOG.NEXTVAL, v_crida_log, 'P_CONSULTAR_SERVEI_WEB', 'RSP', 'S', RSP);
        COMMIT;
      
    END P_consultar_servei_web;
      
  END;

/
